<launch>

    <!-- roslaunch ars_40x ars_40x.launch visualize:=False obstacle_array:=true can_device:=can1 -->
    <!-- <include file='$(find ars_40x)/launch/ars_40x.launch'>
      <arg name="visualize"      value="False" />
      <arg name="obstacle_array" value="true" />
      <arg name="can_device"     value="can1" />
    </include> -->

    <!-- <include file='$(find ars_40x_to_autoware_object)/launch/radar2tfvelodyne.launch'/> -->

    <include file='$(find rslidar_pointcloud)/launch/rs_cloud_nodelet_16.launch'/>
    <include file='$(find rs_to_velodyne)/launch/start.launch'/>

    <arg name="MIN_X" default="-0.5" />
    <arg name="MAX_X" default="2.5" />
    <arg name="MIN_Y" default="-1.2" />
    <arg name="MAX_Y" default="1.2" />
    <arg name="MIN_Z" default="-0.6" />
    <arg name="MAX_Z" default="0.5" />

    <node pkg="rostopic" type="rostopic" name="config_voxel_grid_filter_rostopic"
        args="pub -l /config/my_voxel_grid_filter my_autoware_config_msgs/ConfigVoxelGridFilter 
        '{min_x: $(arg MIN_X),max_x: $(arg MAX_X),min_y: $(arg MIN_Y),max_y: $(arg MAX_Y),min_z: $(arg MIN_Z),max_z: $(arg MAX_Z)}'" 
        />

  <include file='$(find my_points_downsampler)/launch/points_downsample.launch'>
    <arg name="points_topic" default="points_raw" />
  </include>
  <!-- 
    # Ray ground filter #
    filter points below ground
    In:  /points_raw [sensor_msgs::PointCloud2]
    Out: /points_no_ground (points above ground) [sensor_msgs::PointCloud2]
    Out: /points_ground [sensor_msgs::PointCloud2]
  -->
  <include file='$(find points_preprocessor)/launch/ray_ground_filter.launch'>
    <arg name='input_point_topic' value='/my_filtered_points'/> 
    <!-- <arg name='input_point_topic' value='/points_raw'/>  -->
    <arg name='clipping_height' value='3.5'/> <!-- Remove points above this height value -->
    <arg name='min_point_distance' value='0.5'/> <!-- Removes points closer than this distance from the sensor origin -->
    <arg name='radial_divider_angle' value='0.1'/> <!-- Angle of each radial division on the XY plane -->
    <arg name='concentric_divider_distance' value='0.0'/> <!--Angle of each radial division on the XY plane -->
    <arg name='local_max_slope' value='5.0'/> <!-- Max slope of the ground between points -->
    <arg name='general_max_slope' value='3.0'/> <!-- Max slope of the ground in the entire pointCloud, used when reclassification occurs -->
    <arg name='min_height_threshold' value='0.05'/> <!-- Minimum height threshold between points -->
    <arg name='reclass_distance_threshold' value='0.2'/> <!-- Distance between points at which re classification will occur -->

    <arg name='no_ground_point_topic' value='/points_no_ground'/>
    <arg name='ground_point_topic' value='/points_ground'/>
  </include>

</launch>
